<template>
    <div class="friend-card-container">
        <div class="friend-card">
            <img class="profile" :src=friend.image :alt=friend.name>
            <img class="status" v-if="friend.status === 'Alive'" :src="require('@/assets/images/Yes.svg')" alt="Yes image">
            <img class="status" v-else :src="require('@/assets/images/No.svg')" alt="No image">

            <div class="info-container">
                <h2>{{ friend.name }}</h2>
                <div class="social">
                    <a href="https://twitter.com/?lang=it" @click.stop>
                        <img class="social-icon" :src="require('@/assets/images/Twitter.svg')" alt="Twitter icon image">
                    </a>
                    <a href="https://www.linkedin.com/in/paoloitri/" @click.stop>
                        <img class="social-icon" :src="require('@/assets/images/Linkedin.svg')" alt="Linkedin icon image">
                    </a>
                </div>
                <h4>{{ friend.species }}</h4>
                <p>{{ description() }}</p>
            </div>
        </div>
        <hr :class="{ last: lastElement, 'last-row-xxl': lastRowOnXXL }" />
    </div>
</template>


<script>

import { defineComponent } from "vue";
export default defineComponent({
    name: 'FriendCard',
    setup(props) {
        const description = () => {
            return `The character is located at ${props.friend.location.name}, belongs to ${props.friend.species} the species, comes from ${props.friend.origin.name} `
        }
        return {
            description,
            name: props.friend
        }
    },
    props: {
        friend: {
            type: Object
        },
        lastElement: {
            type: Boolean
        },
        lastRowOnXXL: {
            type: Boolean
        }
    }
})

</script>

<style scoped lang="scss">
@import "@/assets/scss/variables";

.friend-card-container {
    max-width: 30em;
    margin: 0 auto;

    .friend-card {
        position: relative;
        text-align: left;

        img.profile {
            width: 100%;
            box-shadow: -5px 5px 10px rgb(116, 116, 116);
            border-radius: 0.8em;
        }

        img.status {
            position: absolute;
            left: 2em;
            top: 1.5em;
            width: 2em;
        }

        .info-container {
            margin-top: 2em;

            h2 {
                margin-top: 1em;
                font-weight: 800;
                display: inline;
            }

            .social {
                float: right;

                img.social-icon {
                    cursor: pointer;
                    width: 2em;
                    border-radius: 0.3em;
                    margin-left: 0.5em;
                }
            }


            h4 {
                font-weight: 700;
                color: $light-grey;
            }

            p {
                -webkit-box-orient: vertical;
                display: -webkit-box;
                -webkit-line-clamp: 3;
                overflow: hidden;
                text-overflow: ellipsis;
                white-space: normal;
            }
        }
    }

    hr {
        margin-top: 3rem;
        margin-bottom: 4rem;
        border: 0;
        border-top: 1px solid rgba(0, 0, 0, 1);

    }
}

@media screen and (max-width: 1199px) {
    hr.last {
        display: none;
    }
}


@media screen and (min-width: 992px) {

    .friend-card-container {
        max-width: 50em;
        padding: 1em;

        .friend-card {
            display: flex;

            img.profile {
                width: unset;
                height: 300px;
            }

            .info-container {
                position: relative;
                margin: 0 1em;
                overflow: hidden;
                word-wrap: break-word;

                h4 {
                    margin-top: 0.5em;
                }

                .social {
                    position: absolute;
                    bottom: 0;

                    .social-icon:first() {
                        margin-left: 0 !important;
                    }
                }
            }
        }

    }
}

@media screen and (min-width: 1400px) {

    h2 {
        -webkit-box-orient: vertical;
        display: -webkit-box !important;
        -webkit-line-clamp: 2;
        overflow: hidden;
        text-overflow: ellipsis;
        white-space: normal;
    }

    hr.last-row-xxl {
        display: none;
    }
}
</style>